
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;main.c,181 :: 		void main() {
;main.c,183 :: 		int i = 0;
	PUSH	W10
	PUSH	W12
	PUSH	W13
;main.c,184 :: 		int flake_size = 0;
;main.c,187 :: 		TRISA = 0x0FFF;        // Bits 13-15 are outputs
	MOV	#4095, W0
	MOV	WREG, TRISA
;main.c,188 :: 		TRISD = 0xFFFF;        // Initialize PORTD as input
	MOV	#65535, W0
	MOV	WREG, TRISD
;main.c,189 :: 		TRISB = 0x0000;        // Initialize PORTB as output
	CLR	TRISB
;main.c,190 :: 		TRISE = 0x000;
	CLR	TRISE
;main.c,193 :: 		Init_MCU();
	CALL	_Init_MCU
;main.c,196 :: 		Init_Sprites();
	CALL	_Init_Sprites
;main.c,199 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,202 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;main.c,203 :: 		Init_Sound();
	CALL	_Init_Sound
;main.c,204 :: 		MP3_Init();
	CALL	_MP3_Init
;main.c,207 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;main.c,213 :: 		UART2_Write_Line("Starting Snowburst.");
	MOV	#lo_addr(?lstr1_main), W10
	CALL	_UART2_Write_Line
;main.c,215 :: 		TP_TFT_Press_Detect();
	CALL	_TP_TFT_Press_Detect
;main.c,216 :: 		TP_TFT_Press_Detect();
	CALL	_TP_TFT_Press_Detect
;main.c,218 :: 		while (1){
L_main0:
;main.c,220 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,223 :: 		ShowTitles();
	CALL	_ShowTitles
;main.c,226 :: 		InitGame();
	CALL	_InitGame
;main.c,228 :: 		while (!game_over) {
L_main2:
	MOV	#lo_addr(_game_over), W0
	CP0	[W0]
	BRA Z	L__main143
	GOTO	L_main3
L__main143:
;main.c,231 :: 		if(play_next_song){
	MOV	#lo_addr(_play_next_song), W0
	CP0	[W0]
	BRA NZ	L__main144
	GOTO	L_main4
L__main144:
;main.c,233 :: 		GetNextSong();
	CALL	_GetNextSong
;main.c,234 :: 		}
	GOTO	L_main5
L_main4:
;main.c,235 :: 		else if( (frame_counter % 2) == 0){
	MOV	#2, W2
	MOV	#0, W3
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	SETM	W4
	CALL	__Modulus_32x32
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__main145
	GOTO	L_main6
L__main145:
;main.c,237 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;main.c,238 :: 		}
L_main6:
L_main5:
;main.c,242 :: 		GetInput();
	CALL	_GetInput
;main.c,245 :: 		MoveFlakes();
	CALL	_MoveFlakes
;main.c,248 :: 		TappedFlake();
	CALL	_TappedFlake
;main.c,251 :: 		ClearFlake();
	CALL	_ClearFlake
;main.c,254 :: 		RenderScreen();
	CALL	_RenderScreen
;main.c,257 :: 		if(muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA NZ	L__main146
	GOTO	L_main7
L__main146:
;main.c,258 :: 		Delay_ms(25);
	MOV	#5, W8
	MOV	#4523, W7
L_main8:
	DEC	W7
	BRA NZ	L_main8
	DEC	W8
	BRA NZ	L_main8
;main.c,259 :: 		}
L_main7:
;main.c,262 :: 		SavePrevValues();
	CALL	_SavePrevValues
;main.c,263 :: 		}
	GOTO	L_main2
L_main3:
;main.c,266 :: 		ShowGameOver();
	CALL	_ShowGameOver
;main.c,267 :: 		}
	GOTO	L_main0
;main.c,269 :: 		}
L_end_main:
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_MoveFlakes:

;main.c,272 :: 		void MoveFlakes(){
;main.c,273 :: 		int i = 0;
	PUSH	W10
;main.c,275 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1); i++){
; i start address is: 14 (W7)
	CLR	W7
; i end address is: 14 (W7)
L_MoveFlakes10:
; i start address is: 14 (W7)
	CP	W7, #2
	BRA LE	L__MoveFlakes149
	GOTO	L_MoveFlakes11
L__MoveFlakes149:
;main.c,277 :: 		flakes[i].y += flakes[i].speed;
	MOV	#18, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #2, W2
	ADD	W0, #16, W1
	MOV	[W2], W0
	ADD	W0, [W1], [W2]
;main.c,280 :: 		if( (long)(flakes[i].y+flakes[i].height+flakes[i].speed) > (long)(240-snow_height-STATUS_TEXT_HEIGHT)){
	MOV	#18, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W4
	ADD	W4, #2, W1
	ADD	W4, #14, W0
	MOV	[W0], W0
	ADD	W0, [W1], W1
	ADD	W4, #16, W0
	ADD	W1, [W0], W0
	MOV	W0, W5
	ASR	W5, #15, W6
	MOV	#240, W3
	MOV	#0, W4
	MOV	#lo_addr(_snow_height), W2
	SUB	W3, [W2++], W0
	SUBB	W4, [W2--], W1
	SUB	W0, #25, W0
	SUBB	W1, #0, W1
	CP	W5, W0
	CPB	W6, W1
	BRA GT	L__MoveFlakes150
	GOTO	L_MoveFlakes13
L__MoveFlakes150:
;main.c,282 :: 		flakeMissed(i);
	PUSH	W7
	MOV	W7, W10
	CALL	_flakeMissed
	POP	W7
;main.c,284 :: 		}
L_MoveFlakes13:
;main.c,275 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1); i++){
	INC	W7
;main.c,286 :: 		}
; i end address is: 14 (W7)
	GOTO	L_MoveFlakes10
L_MoveFlakes11:
;main.c,287 :: 		}
L_end_MoveFlakes:
	POP	W10
	RETURN
; end of _MoveFlakes

_RenderScreen:

;main.c,289 :: 		void RenderScreen(){
;main.c,290 :: 		int i = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,292 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1); i++){
; i start address is: 8 (W4)
	CLR	W4
; i end address is: 8 (W4)
L_RenderScreen14:
; i start address is: 8 (W4)
	CP	W4, #2
	BRA LE	L__RenderScreen152
	GOTO	L_RenderScreen15
L__RenderScreen152:
;main.c,294 :: 		DrawFlake(flakes[i].frame, flakes[i].x, flakes[i].y, flakes[i].scale);
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W3
	ADD	W0, #2, W2
	MOV	[W0], W1
	ADD	W0, #8, W0
	PUSH	W4
	MOV	[W3], W13
	MOV	[W2], W12
	MOV	W1, W11
	MOV	[W0], W10
	CALL	_DrawFlake
	POP	W4
;main.c,297 :: 		flakes[i].frame++;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	MOV	[W1], W0
	INC	W0
	MOV	W0, [W1]
;main.c,299 :: 		if(flakes[i].frame > 13){
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W0
	MOV	[W0], W0
	CP	W0, #13
	BRA GT	L__RenderScreen153
	GOTO	L_RenderScreen17
L__RenderScreen153:
;main.c,300 :: 		flakes[i].frame = 1;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	MOV	#1, W0
	MOV	W0, [W1]
;main.c,301 :: 		}
L_RenderScreen17:
;main.c,292 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1); i++){
	INC	W4
;main.c,302 :: 		}
; i end address is: 8 (W4)
	GOTO	L_RenderScreen14
L_RenderScreen15:
;main.c,305 :: 		DrawSnowFall();
	CALL	_DrawSnowFall
;main.c,308 :: 		RenderScore();
	CALL	_RenderScore
;main.c,310 :: 		}
L_end_RenderScreen:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _RenderScreen

_InitGame:

;main.c,312 :: 		void InitGame(){
;main.c,314 :: 		score = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _score
	MOV	W1, _score+2
;main.c,316 :: 		prev_score = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _prev_score
	MOV	W1, _prev_score+2
;main.c,319 :: 		snow_height = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _snow_height
	MOV	W1, _snow_height+2
;main.c,322 :: 		game_over = 0;
	CLR	W0
	MOV	W0, _game_over
;main.c,323 :: 		}
L_end_InitGame:
	RETURN
; end of _InitGame

_FlakeReset:
	LNK	#12

;main.c,325 :: 		void FlakeReset(int flake_number){
;main.c,326 :: 		int offset = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,327 :: 		int top_clear_flake_pos = 0;
;main.c,329 :: 		int small_speed_boost = 0;
;main.c,330 :: 		int large_speed_boost = 0;
	MOV	#0, W0
	MOV	W0, [W14+2]
;main.c,334 :: 		if(score > 20000){
	MOV	#20000, W1
	MOV	#0, W2
	MOV	#lo_addr(_score), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__FlakeReset156
	GOTO	L_FlakeReset18
L__FlakeReset156:
;main.c,335 :: 		small_speed_boost = 2;
	MOV	#2, W0
	MOV	W0, [W14+0]
;main.c,336 :: 		large_speed_boost = 1;
	MOV	#1, W0
	MOV	W0, [W14+2]
;main.c,337 :: 		}
	GOTO	L_FlakeReset19
L_FlakeReset18:
;main.c,338 :: 		else if(score > 10000){
	MOV	#10000, W1
	MOV	#0, W2
	MOV	#lo_addr(_score), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__FlakeReset157
	GOTO	L_FlakeReset20
L__FlakeReset157:
;main.c,339 :: 		small_speed_boost = 2;
	MOV	#2, W0
	MOV	W0, [W14+0]
;main.c,340 :: 		}
	GOTO	L_FlakeReset21
L_FlakeReset20:
;main.c,341 :: 		else if(score > 5000){
	MOV	#5000, W1
	MOV	#0, W2
	MOV	#lo_addr(_score), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__FlakeReset158
	GOTO	L_FlakeReset22
L__FlakeReset158:
;main.c,342 :: 		small_speed_boost = 1;
	MOV	#1, W0
	MOV	W0, [W14+0]
;main.c,343 :: 		}
	GOTO	L_FlakeReset23
L_FlakeReset22:
;main.c,345 :: 		small_speed_boost = 0;
	CLR	W0
	MOV	W0, [W14+0]
;main.c,346 :: 		large_speed_boost = 0;
	CLR	W0
	MOV	W0, [W14+2]
;main.c,347 :: 		}
L_FlakeReset23:
L_FlakeReset21:
L_FlakeReset19:
;main.c,352 :: 		TFT_Set_Pen(sky_color, 1);
	PUSH	W10
	MOV	#1, W11
	MOV	_sky_color, W10
	CALL	_TFT_Set_Pen
;main.c,355 :: 		TFT_Set_Brush(1, sky_color, 0, TOP_TO_BOTTOM, sky_color, sky_color);
	CLR	W13
	CLR	W12
	MOV	_sky_color, W11
	MOV	#1, W10
	PUSH	_sky_color
	PUSH	_sky_color
	CALL	_TFT_Set_Brush
	SUB	#4, W15
	POP	W10
;main.c,361 :: 		top_clear_flake_pos = flakes[flake_number].y-flakes[flake_number].speed;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #2, W1
	ADD	W0, #16, W0
	MOV	[W0], W0
	SUBR	W0, [W1], W0
; top_clear_flake_pos start address is: 12 (W6)
	MOV	W0, W6
;main.c,362 :: 		if(top_clear_flake_pos < 0){
	CP	W0, #0
	BRA LT	L__FlakeReset159
	GOTO	L__FlakeReset128
L__FlakeReset159:
;main.c,363 :: 		top_clear_flake_pos = 0;
	CLR	W6
; top_clear_flake_pos end address is: 12 (W6)
	MOV	W6, W4
;main.c,364 :: 		}
	GOTO	L_FlakeReset24
L__FlakeReset128:
;main.c,362 :: 		if(top_clear_flake_pos < 0){
	MOV	W6, W4
;main.c,364 :: 		}
L_FlakeReset24:
;main.c,367 :: 		TFT_Rectangle(flakes[flake_number].x,top_clear_flake_pos, flakes[flake_number].x+flakes[flake_number].width, flakes[flake_number].y+flakes[flake_number].height);
; top_clear_flake_pos start address is: 8 (W4)
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W3
	ADD	W3, #2, W1
	ADD	W3, #14, W0
	MOV	[W0], W0
	ADD	W0, [W1], W2
	MOV	[W3], W1
	ADD	W3, #12, W0
	ADD	W1, [W0], W0
	PUSH	W10
	MOV	W2, W13
	MOV	W0, W12
	MOV	W4, W11
; top_clear_flake_pos end address is: 8 (W4)
	MOV	W1, W10
	CALL	_TFT_Rectangle
	POP	W10
;main.c,370 :: 		flakes[flake_number].x = ((320 + 32)/ NUMBER_OF_FLAKES) * flake_number + ( getRandom(120) - 60);
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	MOV	W0, [W14+10]
	MOV	#117, W0
	MUL.SS	W0, W10, W0
	MOV	W0, [W14+8]
	PUSH	W10
	MOV	#120, W10
	CALL	_GetRandom
	POP	W10
	MOV	#60, W1
	SUB	W0, W1, W3
	MOV	[W14+10], W2
	MOV	[W14+8], W0
	ADD	W0, W3, [W2]
;main.c,373 :: 		if(  flakes[flake_number].x < 0){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__FlakeReset160
	GOTO	L_FlakeReset25
L__FlakeReset160:
;main.c,374 :: 		flakes[flake_number].x = 0;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W1
	CLR	W0
	MOV	W0, [W1]
;main.c,375 :: 		}
L_FlakeReset25:
;main.c,376 :: 		if(  flakes[flake_number].x > 290){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	MOV	[W0], W1
	MOV	#290, W0
	CP	W1, W0
	BRA GT	L__FlakeReset161
	GOTO	L_FlakeReset26
L__FlakeReset161:
;main.c,377 :: 		flakes[flake_number].x = 290;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W1
	MOV	#290, W0
	MOV	W0, [W1]
;main.c,378 :: 		}
L_FlakeReset26:
;main.c,381 :: 		flakes[flake_number].y = 0;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #2, W1
	CLR	W0
	MOV	W0, [W1]
;main.c,383 :: 		flakes[flake_number].prev_x = flakes[flake_number].x;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W1
	MOV	[W0], W0
	MOV	W0, [W1]
;main.c,384 :: 		flakes[flake_number].prev_y = flakes[flake_number].y;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	INC2	W0
	MOV	[W0], [W1]
;main.c,387 :: 		flakes[flake_number].frame = getRandom(13);
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W0
	MOV	W0, [W14+8]
	PUSH	W10
	MOV	#13, W10
	CALL	_GetRandom
	POP	W10
	MOV	[W14+8], W1
	MOV	W0, [W1]
;main.c,391 :: 		flakes[flake_number].scale = getRandom(2);
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	W0, [W14+8]
	PUSH	W10
	MOV	#2, W10
	CALL	_GetRandom
	POP	W10
	MOV	[W14+8], W1
	MOV	W0, [W1]
;main.c,394 :: 		if(flakes[flake_number].scale == 1){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__FlakeReset162
	GOTO	L_FlakeReset27
L__FlakeReset162:
;main.c,395 :: 		flakes[flake_number].width = 32;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #12, W1
	MOV	#32, W0
	MOV	W0, [W1]
;main.c,396 :: 		flakes[flake_number].height = 32;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W1
	MOV	#32, W0
	MOV	W0, [W1]
;main.c,397 :: 		}
	GOTO	L_FlakeReset28
L_FlakeReset27:
;main.c,399 :: 		flakes[flake_number].width = 64;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #12, W1
	MOV	#64, W0
	MOV	W0, [W1]
;main.c,400 :: 		flakes[flake_number].height = 64;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W1
	MOV	#64, W0
	MOV	W0, [W1]
;main.c,401 :: 		}
L_FlakeReset28:
;main.c,410 :: 		if (flakes[flake_number].scale  == 1){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__FlakeReset163
	GOTO	L_FlakeReset29
L__FlakeReset163:
;main.c,412 :: 		flakes[flake_number].speed = getRandom(4)+small_speed_boost;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W0
	MOV	W0, [W14+8]
	MOV	#4, W10
	CALL	_GetRandom
	ADD	W14, #0, W2
	MOV	[W14+8], W1
	ADD	W0, [W2], [W1]
;main.c,413 :: 		}
	GOTO	L_FlakeReset30
L_FlakeReset29:
;main.c,416 :: 		flakes[flake_number].speed = getRandom(3)+large_speed_boost;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W0
	MOV	W0, [W14+8]
	MOV	#3, W10
	CALL	_GetRandom
	ADD	W14, #2, W2
	MOV	[W14+8], W1
	ADD	W0, [W2], [W1]
;main.c,417 :: 		}
L_FlakeReset30:
;main.c,419 :: 		}
L_end_FlakeReset:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _FlakeReset

_SavePrevValues:

;main.c,422 :: 		void SavePrevValues(){
;main.c,426 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,429 :: 		prev_snow_height = snow_height;
	MOV	_snow_height, W0
	MOV	_snow_height+2, W1
	MOV	W0, _prev_snow_height
	MOV	W1, _prev_snow_height+2
;main.c,432 :: 		prev_score = score;
	MOV	_score, W0
	MOV	_score+2, W1
	MOV	W0, _prev_score
	MOV	W1, _prev_score+2
;main.c,436 :: 		prev_muteSound = muteSound;
	MOV	_muteSound, W0
	MOV	W0, _prev_muteSound
;main.c,439 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
; i start address is: 8 (W4)
	CLR	W4
; i end address is: 8 (W4)
L_SavePrevValues31:
; i start address is: 8 (W4)
	CP	W4, #2
	BRA LE	L__SavePrevValues165
	GOTO	L_SavePrevValues32
L__SavePrevValues165:
;main.c,440 :: 		flakes[i].prev_x = flakes[i].x;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W1
	MOV	[W0], W0
	MOV	W0, [W1]
;main.c,441 :: 		flakes[i].prev_y = flakes[i].y;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	INC2	W0
	MOV	[W0], [W1]
;main.c,439 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
	INC	W4
;main.c,442 :: 		}
; i end address is: 8 (W4)
	GOTO	L_SavePrevValues31
L_SavePrevValues32:
;main.c,443 :: 		}
L_end_SavePrevValues:
	RETURN
; end of _SavePrevValues

_FlakeMissed:

;main.c,445 :: 		void FlakeMissed(int flake_number)
;main.c,449 :: 		if(flakes[flake_number].scale == 1){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__FlakeMissed167
	GOTO	L_FlakeMissed34
L__FlakeMissed167:
;main.c,452 :: 		if(snow_height > 120){
	MOV	#120, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__FlakeMissed168
	GOTO	L_FlakeMissed35
L__FlakeMissed168:
;main.c,454 :: 		snow_height+=3;
	MOV	#3, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,455 :: 		}
	GOTO	L_FlakeMissed36
L_FlakeMissed35:
;main.c,458 :: 		snow_height+=7;
	MOV	#7, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,459 :: 		}
L_FlakeMissed36:
;main.c,461 :: 		}
	GOTO	L_FlakeMissed37
L_FlakeMissed34:
;main.c,463 :: 		else if(flakes[flake_number].scale ==2){
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #2
	BRA Z	L__FlakeMissed169
	GOTO	L_FlakeMissed38
L__FlakeMissed169:
;main.c,465 :: 		if(snow_height > 120){
	MOV	#120, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__FlakeMissed170
	GOTO	L_FlakeMissed39
L__FlakeMissed170:
;main.c,467 :: 		snow_height+=7;
	MOV	#7, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,468 :: 		}
	GOTO	L_FlakeMissed40
L_FlakeMissed39:
;main.c,471 :: 		snow_height+=15;
	MOV	#15, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,472 :: 		}
L_FlakeMissed40:
;main.c,474 :: 		}
L_FlakeMissed38:
L_FlakeMissed37:
;main.c,476 :: 		FlakeReset(flake_number);
	CALL	_FlakeReset
;main.c,478 :: 		}
L_end_FlakeMissed:
	RETURN
; end of _FlakeMissed

_TappedFlake:

;main.c,481 :: 		void TappedFlake(){
;main.c,484 :: 		int tapped_flake_size = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,488 :: 		if( Pen_Down && (abs(X_Drag_Distance) < 10)  ){
	MOV	#lo_addr(_Pen_Down), W0
	CP0.B	[W0]
	BRA NZ	L__TappedFlake172
	GOTO	L__TappedFlake131
L__TappedFlake172:
	MOV	_X_Drag_Distance, W10
	CALL	_abs
	CP	W0, #10
	BRA LT	L__TappedFlake173
	GOTO	L__TappedFlake130
L__TappedFlake173:
L__TappedFlake129:
;main.c,491 :: 		for(i=0;i<NUMBER_OF_FLAKES;i++){
; i start address is: 12 (W6)
	CLR	W6
; i end address is: 12 (W6)
L_TappedFlake44:
; i start address is: 12 (W6)
	CP	W6, #3
	BRA LT	L__TappedFlake174
	GOTO	L_TappedFlake45
L__TappedFlake174:
;main.c,494 :: 		if(IsCollision (X_Coord-TAP_RADIUS, Y_Coord-TAP_RADIUS, TAP_RADIUS*2, TAP_RADIUS*2, flakes[i].x, flakes[i].y, flakes[i].width, flakes[i].height) ){
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W1
	ADD	W1, #14, W0
	MOV	[W0], W5
	ADD	W1, #12, W0
	MOV	[W0], W4
	ADD	W1, #2, W0
	MOV	[W0], W3
	MOV	[W1], W2
	MOV	_Y_Coord, W0
	SUB	W0, #15, W1
	MOV	_X_Coord, W0
	SUB	W0, #15, W0
	PUSH	W6
	MOV	#30, W13
	MOV	#30, W12
	MOV	W1, W11
	MOV	W0, W10
	PUSH	W5
	PUSH	W4
	PUSH	W3
	PUSH	W2
	CALL	_IsCollision
	SUB	#8, W15
	POP	W6
	CP0.B	W0
	BRA NZ	L__TappedFlake175
	GOTO	L_TappedFlake47
L__TappedFlake175:
;main.c,497 :: 		if(flakes[i].scale == 1){
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__TappedFlake176
	GOTO	L_TappedFlake48
L__TappedFlake176:
;main.c,499 :: 		score+= 50;
	MOV	#50, W1
	MOV	#0, W2
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,500 :: 		}
	GOTO	L_TappedFlake49
L_TappedFlake48:
;main.c,503 :: 		score+= 25;
	MOV	#25, W1
	MOV	#0, W2
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;main.c,504 :: 		}
L_TappedFlake49:
;main.c,509 :: 		FlakeReset(i);
	PUSH	W6
	MOV	W6, W10
	CALL	_FlakeReset
	POP	W6
;main.c,511 :: 		}
L_TappedFlake47:
;main.c,491 :: 		for(i=0;i<NUMBER_OF_FLAKES;i++){
	INC	W6
;main.c,513 :: 		}
; i end address is: 12 (W6)
	GOTO	L_TappedFlake44
L_TappedFlake45:
;main.c,488 :: 		if( Pen_Down && (abs(X_Drag_Distance) < 10)  ){
L__TappedFlake131:
L__TappedFlake130:
;main.c,517 :: 		}
L_end_TappedFlake:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _TappedFlake

_DrawFlake:

;main.c,520 :: 		void DrawFlake(int frame, int x, int y, int scale){
;main.c,522 :: 		switch (frame) {
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	GOTO	L_DrawFlake50
;main.c,523 :: 		case 0:
L_DrawFlake52:
;main.c,524 :: 		TFT_Image(x, y, snowflake1_bmp, scale);
	MOV	#lo_addr(_snowflake1_bmp), W0
	MOV	#higher_addr(_snowflake1_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,525 :: 		break;
	GOTO	L_DrawFlake51
;main.c,527 :: 		case 1:
L_DrawFlake53:
;main.c,528 :: 		TFT_Image(x, y, snowflake1_bmp, scale);
	MOV	#lo_addr(_snowflake1_bmp), W0
	MOV	#higher_addr(_snowflake1_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,529 :: 		break;
	GOTO	L_DrawFlake51
;main.c,531 :: 		case 2:
L_DrawFlake54:
;main.c,532 :: 		TFT_Image(x, y, snowflake2_bmp, scale);
	MOV	#lo_addr(_snowflake2_bmp), W0
	MOV	#higher_addr(_snowflake2_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,533 :: 		break;
	GOTO	L_DrawFlake51
;main.c,535 :: 		case 3:
L_DrawFlake55:
;main.c,536 :: 		TFT_Image(x, y, snowflake3_bmp, scale);
	MOV	#lo_addr(_snowflake3_bmp), W0
	MOV	#higher_addr(_snowflake3_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,537 :: 		break;
	GOTO	L_DrawFlake51
;main.c,539 :: 		case 4:
L_DrawFlake56:
;main.c,540 :: 		TFT_Image(x, y, snowflake4_bmp, scale);
	MOV	#lo_addr(_snowflake4_bmp), W0
	MOV	#higher_addr(_snowflake4_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,541 :: 		break;
	GOTO	L_DrawFlake51
;main.c,543 :: 		case 5:
L_DrawFlake57:
;main.c,544 :: 		TFT_Image(x, y, snowflake5_bmp, scale);
	MOV	#lo_addr(_snowflake5_bmp), W0
	MOV	#higher_addr(_snowflake5_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,545 :: 		break;
	GOTO	L_DrawFlake51
;main.c,547 :: 		case 6:
L_DrawFlake58:
;main.c,548 :: 		TFT_Image(x, y, snowflake6_bmp, scale);
	MOV	#lo_addr(_snowflake6_bmp), W0
	MOV	#higher_addr(_snowflake6_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,549 :: 		break;
	GOTO	L_DrawFlake51
;main.c,551 :: 		case 7:
L_DrawFlake59:
;main.c,552 :: 		TFT_Image(x, y, snowflake7_bmp, scale);
	MOV	#lo_addr(_snowflake7_bmp), W0
	MOV	#higher_addr(_snowflake7_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,553 :: 		break;
	GOTO	L_DrawFlake51
;main.c,555 :: 		case 8:
L_DrawFlake60:
;main.c,556 :: 		TFT_Image(x, y, snowflake8_bmp, scale);
	MOV	#lo_addr(_snowflake8_bmp), W0
	MOV	#higher_addr(_snowflake8_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,557 :: 		break;
	GOTO	L_DrawFlake51
;main.c,559 :: 		case 9:
L_DrawFlake61:
;main.c,560 :: 		TFT_Image(x, y, snowflake9_bmp, scale);
	MOV	#lo_addr(_snowflake9_bmp), W0
	MOV	#higher_addr(_snowflake9_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,561 :: 		break;
	GOTO	L_DrawFlake51
;main.c,563 :: 		case 10:
L_DrawFlake62:
;main.c,564 :: 		TFT_Image(x, y, snowflake10_bmp, scale);
	MOV	#lo_addr(_snowflake10_bmp), W0
	MOV	#higher_addr(_snowflake10_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,565 :: 		break;
	GOTO	L_DrawFlake51
;main.c,567 :: 		case 11:
L_DrawFlake63:
;main.c,568 :: 		TFT_Image(x, y, snowflake11_bmp, scale);
	MOV	#lo_addr(_snowflake11_bmp), W0
	MOV	#higher_addr(_snowflake11_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,569 :: 		break;
	GOTO	L_DrawFlake51
;main.c,571 :: 		case 12:
L_DrawFlake64:
;main.c,572 :: 		TFT_Image(x, y, snowflake12_bmp, scale);
	MOV	#lo_addr(_snowflake12_bmp), W0
	MOV	#higher_addr(_snowflake12_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,573 :: 		break;
	GOTO	L_DrawFlake51
;main.c,575 :: 		case 13:
L_DrawFlake65:
;main.c,576 :: 		TFT_Image(x, y, snowflake13_bmp, scale);
	MOV	#lo_addr(_snowflake13_bmp), W0
	MOV	#higher_addr(_snowflake13_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,577 :: 		break;
	GOTO	L_DrawFlake51
;main.c,579 :: 		case 14:
L_DrawFlake66:
;main.c,580 :: 		TFT_Image(x, y, snowflake14_bmp, scale);
	MOV	#lo_addr(_snowflake14_bmp), W0
	MOV	#higher_addr(_snowflake14_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,581 :: 		break;
	GOTO	L_DrawFlake51
;main.c,583 :: 		default:
L_DrawFlake67:
;main.c,584 :: 		TFT_Image(x, y, snowflake1_bmp, scale);
	MOV	#lo_addr(_snowflake1_bmp), W0
	MOV	#higher_addr(_snowflake1_bmp), W1
	PUSH	W13
	MOV	W11, W10
	MOV	W12, W11
	MOV.D	W0, W12
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,586 :: 		}
	GOTO	L_DrawFlake51
L_DrawFlake50:
	CP	W10, #0
	BRA NZ	L__DrawFlake178
	GOTO	L_DrawFlake52
L__DrawFlake178:
	CP	W10, #1
	BRA NZ	L__DrawFlake179
	GOTO	L_DrawFlake53
L__DrawFlake179:
	CP	W10, #2
	BRA NZ	L__DrawFlake180
	GOTO	L_DrawFlake54
L__DrawFlake180:
	CP	W10, #3
	BRA NZ	L__DrawFlake181
	GOTO	L_DrawFlake55
L__DrawFlake181:
	CP	W10, #4
	BRA NZ	L__DrawFlake182
	GOTO	L_DrawFlake56
L__DrawFlake182:
	CP	W10, #5
	BRA NZ	L__DrawFlake183
	GOTO	L_DrawFlake57
L__DrawFlake183:
	CP	W10, #6
	BRA NZ	L__DrawFlake184
	GOTO	L_DrawFlake58
L__DrawFlake184:
	CP	W10, #7
	BRA NZ	L__DrawFlake185
	GOTO	L_DrawFlake59
L__DrawFlake185:
	CP	W10, #8
	BRA NZ	L__DrawFlake186
	GOTO	L_DrawFlake60
L__DrawFlake186:
	CP	W10, #9
	BRA NZ	L__DrawFlake187
	GOTO	L_DrawFlake61
L__DrawFlake187:
	CP	W10, #10
	BRA NZ	L__DrawFlake188
	GOTO	L_DrawFlake62
L__DrawFlake188:
	CP	W10, #11
	BRA NZ	L__DrawFlake189
	GOTO	L_DrawFlake63
L__DrawFlake189:
	CP	W10, #12
	BRA NZ	L__DrawFlake190
	GOTO	L_DrawFlake64
L__DrawFlake190:
	CP	W10, #13
	BRA NZ	L__DrawFlake191
	GOTO	L_DrawFlake65
L__DrawFlake191:
	CP	W10, #14
	BRA NZ	L__DrawFlake192
	GOTO	L_DrawFlake66
L__DrawFlake192:
	GOTO	L_DrawFlake67
L_DrawFlake51:
;main.c,589 :: 		}
L_end_DrawFlake:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _DrawFlake

_Init_Sprites:
	LNK	#4

;main.c,595 :: 		void Init_Sprites(){
;main.c,596 :: 		int random_x = 0;
	PUSH	W10
;main.c,597 :: 		int i = 0;
;main.c,599 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
; i start address is: 12 (W6)
	CLR	W6
; i end address is: 12 (W6)
L_Init_Sprites68:
; i start address is: 12 (W6)
	CP	W6, #2
	BRA LE	L__Init_Sprites194
	GOTO	L_Init_Sprites69
L__Init_Sprites194:
;main.c,603 :: 		flakes[i].x = ((320 + 32)/ NUMBER_OF_FLAKES) * i + getRandom(32);
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	MOV	W0, [W14+2]
	MOV	#117, W0
	MUL.SS	W0, W6, W0
	MOV	W0, [W14+0]
	MOV	#32, W10
	CALL	_GetRandom
	MOV	[W14+2], W1
	MOV	[W14+0], W2
	ADD	W2, W0, [W1]
;main.c,604 :: 		flakes[i].y = getRandom(5) * 48;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	INC2	W0
	MOV	W0, [W14+0]
	MOV	#5, W10
	CALL	_GetRandom
	MOV	#48, W1
	MUL.SS	W0, W1, W2
	MOV	[W14+0], W0
	MOV	W2, [W0]
;main.c,607 :: 		flakes[i].prev_x = flakes[i].x;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W1
	MOV	[W0], W0
	MOV	W0, [W1]
;main.c,608 :: 		flakes[i].prev_y = flakes[i].y;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	INC2	W0
	MOV	[W0], [W1]
;main.c,612 :: 		flakes[i].frame = getRandom(13);
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W0
	MOV	W0, [W14+0]
	MOV	#13, W10
	CALL	_GetRandom
	MOV	[W14+0], W1
	MOV	W0, [W1]
;main.c,616 :: 		flakes[i].scale = getRandom(2);
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	W0, [W14+0]
	MOV	#2, W10
	CALL	_GetRandom
	MOV	[W14+0], W1
	MOV	W0, [W1]
;main.c,619 :: 		if(flakes[i].scale == 1){
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__Init_Sprites195
	GOTO	L_Init_Sprites71
L__Init_Sprites195:
;main.c,620 :: 		flakes[i].width = 32;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #12, W1
	MOV	#32, W0
	MOV	W0, [W1]
;main.c,621 :: 		flakes[i].height = 32;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W1
	MOV	#32, W0
	MOV	W0, [W1]
;main.c,622 :: 		}
	GOTO	L_Init_Sprites72
L_Init_Sprites71:
;main.c,624 :: 		flakes[i].width = 64;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #12, W1
	MOV	#64, W0
	MOV	W0, [W1]
;main.c,625 :: 		flakes[i].height = 64;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W1
	MOV	#64, W0
	MOV	W0, [W1]
;main.c,626 :: 		}
L_Init_Sprites72:
;main.c,630 :: 		flakes[i].speed = getRandom(4);
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W0
	MOV	W0, [W14+0]
	MOV	#4, W10
	CALL	_GetRandom
	MOV	[W14+0], W1
	MOV	W0, [W1]
;main.c,599 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
	INC	W6
;main.c,633 :: 		}
; i end address is: 12 (W6)
	GOTO	L_Init_Sprites68
L_Init_Sprites69:
;main.c,635 :: 		}
L_end_Init_Sprites:
	POP	W10
	ULNK
	RETURN
; end of _Init_Sprites

_DrawSnowFall:

;main.c,638 :: 		void DrawSnowFall(){
;main.c,640 :: 		long screen_snow_height = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,641 :: 		long prev_screen_snow_height = 0;
;main.c,644 :: 		if(snow_height > (long)(240-64-STATUS_TEXT_HEIGHT)){
	MOV	_snow_height, W2
	MOV	_snow_height+2, W3
	MOV	#151, W0
	MOV	#0, W1
	CP	W2, W0
	CPB	W3, W1
	BRA GT	L__DrawSnowFall197
	GOTO	L_DrawSnowFall73
L__DrawSnowFall197:
;main.c,645 :: 		game_over = 1;
	MOV	#1, W0
	MOV	W0, _game_over
;main.c,646 :: 		}
L_DrawSnowFall73:
;main.c,648 :: 		if( (prev_muteSound != muteSound) || (snow_height != prev_snow_height) || (score != prev_score) || (frame_counter < 1) ){
	MOV	_prev_muteSound, W1
	MOV	#lo_addr(_muteSound), W0
	CP	W1, [W0]
	BRA Z	L__DrawSnowFall198
	GOTO	L__DrawSnowFall137
L__DrawSnowFall198:
	MOV	_snow_height, W1
	MOV	_snow_height+2, W2
	MOV	#lo_addr(_prev_snow_height), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA Z	L__DrawSnowFall199
	GOTO	L__DrawSnowFall136
L__DrawSnowFall199:
	MOV	_score, W1
	MOV	_score+2, W2
	MOV	#lo_addr(_prev_score), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA Z	L__DrawSnowFall200
	GOTO	L__DrawSnowFall135
L__DrawSnowFall200:
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	CP	W0, #1
	CPB	W1, #0
	BRA GE	L__DrawSnowFall201
	GOTO	L__DrawSnowFall134
L__DrawSnowFall201:
	GOTO	L_DrawSnowFall76
L__DrawSnowFall137:
L__DrawSnowFall136:
L__DrawSnowFall135:
L__DrawSnowFall134:
;main.c,651 :: 		if(  ((score % (long)500) == 0) && (score>(long)50)){
	MOV	#500, W2
	MOV	#0, W3
	MOV	_score, W0
	MOV	_score+2, W1
	SETM	W4
	CALL	__Modulus_32x32
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__DrawSnowFall202
	GOTO	L__DrawSnowFall139
L__DrawSnowFall202:
	MOV	_score, W2
	MOV	_score+2, W3
	MOV	#50, W0
	MOV	#0, W1
	CP	W2, W0
	CPB	W3, W1
	BRA GT	L__DrawSnowFall203
	GOTO	L__DrawSnowFall138
L__DrawSnowFall203:
L__DrawSnowFall132:
;main.c,656 :: 		if (snow_height>64){
	MOV	#64, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LT	L__DrawSnowFall204
	GOTO	L_DrawSnowFall80
L__DrawSnowFall204:
;main.c,658 :: 		snow_height-=50;
	MOV	#50, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	SUBR	W1, [W0], [W0++]
	SUBBR	W2, [W0], [W0--]
;main.c,659 :: 		}
	GOTO	L_DrawSnowFall81
L_DrawSnowFall80:
;main.c,662 :: 		snow_height-=7;
	MOV	#7, W1
	MOV	#0, W2
	MOV	#lo_addr(_snow_height), W0
	SUBR	W1, [W0], [W0++]
	SUBBR	W2, [W0], [W0--]
;main.c,663 :: 		}
L_DrawSnowFall81:
;main.c,668 :: 		UART2_Write_Line("You lowered the snowbank.");
	MOV	#lo_addr(?lstr2_main), W10
	CALL	_UART2_Write_Line
;main.c,671 :: 		if(snow_height<0){
	MOV	_snow_height, W0
	MOV	_snow_height+2, W1
	CP	W0, #0
	CPB	W1, #0
	BRA LT	L__DrawSnowFall205
	GOTO	L_DrawSnowFall82
L__DrawSnowFall205:
;main.c,672 :: 		snow_height=0;
	CLR	W0
	CLR	W1
	MOV	W0, _snow_height
	MOV	W1, _snow_height+2
;main.c,673 :: 		}
L_DrawSnowFall82:
;main.c,675 :: 		screen_snow_height = (long)240-snow_height-STATUS_TEXT_HEIGHT;
	MOV	#240, W3
	MOV	#0, W4
	MOV	#lo_addr(_snow_height), W2
	SUB	W3, [W2++], W0
	SUBB	W4, [W2--], W1
	SUB	W0, #25, W5
	SUBB	W1, #0, W6
; screen_snow_height start address is: 14 (W7)
	MOV	W5, W7
	MOV	W6, W8
;main.c,676 :: 		prev_screen_snow_height = (long)240-prev_snow_height-STATUS_TEXT_HEIGHT;
	MOV	#240, W3
	MOV	#0, W4
	MOV	#lo_addr(_prev_snow_height), W2
	SUB	W3, [W2++], W0
	SUBB	W4, [W2--], W1
; prev_screen_snow_height start address is: 0 (W0)
	SUB	W0, #25, W0
	SUBB	W1, #0, W1
;main.c,681 :: 		if(screen_snow_height<0){
	CP	W5, #0
	CPB	W6, #0
	BRA LT	L__DrawSnowFall206
	GOTO	L__DrawSnowFall140
L__DrawSnowFall206:
; screen_snow_height end address is: 14 (W7)
;main.c,682 :: 		screen_snow_height=0;
; screen_snow_height start address is: 4 (W2)
	CLR	W2
	CLR	W3
; screen_snow_height end address is: 4 (W2)
;main.c,683 :: 		}
	GOTO	L_DrawSnowFall83
L__DrawSnowFall140:
;main.c,681 :: 		if(screen_snow_height<0){
	MOV	W7, W2
	MOV	W8, W3
;main.c,683 :: 		}
L_DrawSnowFall83:
;main.c,686 :: 		if(prev_screen_snow_height<0){
; screen_snow_height start address is: 4 (W2)
	CP	W0, #0
	CPB	W1, #0
	BRA LT	L__DrawSnowFall207
	GOTO	L__DrawSnowFall141
L__DrawSnowFall207:
;main.c,687 :: 		prev_screen_snow_height=0;
	CLR	W0
	CLR	W1
; prev_screen_snow_height end address is: 0 (W0)
	MOV.D	W0, W4
;main.c,688 :: 		}
	GOTO	L_DrawSnowFall84
L__DrawSnowFall141:
;main.c,686 :: 		if(prev_screen_snow_height<0){
	MOV.D	W0, W4
;main.c,688 :: 		}
L_DrawSnowFall84:
;main.c,691 :: 		TFT_Set_Pen(sky_color, 1);
; prev_screen_snow_height start address is: 8 (W4)
	MOV	#1, W11
	MOV	_sky_color, W10
	CALL	_TFT_Set_Pen
;main.c,694 :: 		TFT_Set_Brush(1, sky_color, 0, TOP_TO_BOTTOM, sky_color, sky_color);
	CLR	W13
	CLR	W12
	MOV	_sky_color, W11
	MOV	#1, W10
	PUSH	_sky_color
	PUSH	_sky_color
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;main.c,697 :: 		TFT_Rectangle(0, prev_screen_snow_height, SCREEN_WIDTH, screen_snow_height);
	MOV	W2, W13
; screen_snow_height end address is: 4 (W2)
	MOV	#320, W12
	MOV	W4, W11
; prev_screen_snow_height end address is: 8 (W4)
	CLR	W10
	CALL	_TFT_Rectangle
;main.c,651 :: 		if(  ((score % (long)500) == 0) && (score>(long)50)){
L__DrawSnowFall139:
L__DrawSnowFall138:
;main.c,706 :: 		TFT_Set_Pen(0, 0);
	CLR	W11
	CLR	W10
	CALL	_TFT_Set_Pen
;main.c,712 :: 		TFT_Set_Brush(1, 0, 1, TOP_TO_BOTTOM, CL_WHITE, CL_GRAY);
	CLR	W13
	MOV	#1, W12
	CLR	W11
	MOV	#1, W10
	MOV	#33808, W0
	PUSH	W0
	MOV	#65535, W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;main.c,718 :: 		TFT_Rectangle(0, 240-snow_height-STATUS_TEXT_HEIGHT, 319, 240);
	MOV	#240, W2
	MOV	#lo_addr(_snow_height), W1
	SUB	W2, [W1], W0
	SUB	W0, #25, W0
	MOV	#240, W13
	MOV	#319, W12
	MOV	W0, W11
	CLR	W10
	CALL	_TFT_Rectangle
;main.c,720 :: 		}
L_DrawSnowFall76:
;main.c,721 :: 		}
L_end_DrawSnowFall:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _DrawSnowFall

_GetRandom:

;main.c,725 :: 		int GetRandom(int range){
;main.c,726 :: 		return (rand() % range) + 1;
	CALL	_rand
	REPEAT	#17
	DIV.S	W0, W10
	MOV	W1, W0
	INC	W0
;main.c,727 :: 		}
L_end_GetRandom:
	RETURN
; end of _GetRandom

_GetInput:

;main.c,731 :: 		void GetInput(){
;main.c,733 :: 		if(TP_TFT_Press_Detect()){
	PUSH	W10
	PUSH	W11
	CALL	_TP_TFT_Press_Detect
	CP0.B	W0
	BRA NZ	L__GetInput210
	GOTO	L_GetInput85
L__GetInput210:
;main.c,735 :: 		if (TP_TFT_Get_Coordinates(&X_Coord, &Y_Coord) == 0) {
	MOV	#lo_addr(_Y_Coord), W11
	MOV	#lo_addr(_X_Coord), W10
	CALL	_TP_TFT_Get_Coordinates
	CP.B	W0, #0
	BRA Z	L__GetInput211
	GOTO	L_GetInput86
L__GetInput211:
;main.c,738 :: 		if(Pen_Down == 0){
	MOV	#lo_addr(_Pen_Down), W0
	MOV.B	[W0], W0
	CP.B	W0, #0
	BRA Z	L__GetInput212
	GOTO	L_GetInput87
L__GetInput212:
;main.c,739 :: 		Starting_Pen_Down_X_Coord = X_Coord;
	MOV	_X_Coord, W0
	MOV	W0, _Starting_Pen_Down_X_Coord
;main.c,740 :: 		Starting_Pen_Down_Y_Coord = Y_Coord;
	MOV	_Y_Coord, W0
	MOV	W0, _Starting_Pen_Down_Y_Coord
;main.c,743 :: 		}
L_GetInput87:
;main.c,745 :: 		X_Drag_Distance =  Starting_Pen_Down_X_Coord - X_Coord;
	MOV	_Starting_Pen_Down_X_Coord, W2
	MOV	#lo_addr(_X_Coord), W1
	MOV	#lo_addr(_X_Drag_Distance), W0
	SUB	W2, [W1], [W0]
;main.c,748 :: 		Pen_Down = 1;
	MOV	#lo_addr(_Pen_Down), W1
	MOV.B	#1, W0
	MOV.B	W0, [W1]
;main.c,750 :: 		}  //end of tap x / y location checking
L_GetInput86:
;main.c,752 :: 		}
	GOTO	L_GetInput88
L_GetInput85:
;main.c,755 :: 		Pen_Down = 0;
	MOV	#lo_addr(_Pen_Down), W1
	CLR	W0
	MOV.B	W0, [W1]
;main.c,756 :: 		}
L_GetInput88:
;main.c,759 :: 		if( (Pen_Down == 1 )&& (Y_coord > (SCREEN_HEIGHT-STATUS_TEXT_HEIGHT)) ) {
	MOV	#lo_addr(_Pen_Down), W0
	MOV.B	[W0], W0
	CP.B	W0, #1
	BRA Z	L__GetInput213
	GOTO	L__GetInput127
L__GetInput213:
	MOV	#215, W1
	MOV	#lo_addr(_Y_Coord), W0
	CP	W1, [W0]
	BRA LTU	L__GetInput214
	GOTO	L__GetInput126
L__GetInput214:
L__GetInput125:
;main.c,761 :: 		ToggleMute();
	CALL	_ToggleMute
;main.c,762 :: 		Delay_ms(500);
	MOV	#82, W8
	MOV	#24943, W7
L_GetInput92:
	DEC	W7
	BRA NZ	L_GetInput92
	DEC	W8
	BRA NZ	L_GetInput92
	NOP
;main.c,759 :: 		if( (Pen_Down == 1 )&& (Y_coord > (SCREEN_HEIGHT-STATUS_TEXT_HEIGHT)) ) {
L__GetInput127:
L__GetInput126:
;main.c,765 :: 		}
L_end_GetInput:
	POP	W11
	POP	W10
	RETURN
; end of _GetInput

_ClearFlake:

;main.c,769 :: 		void ClearFlake(){
;main.c,770 :: 		int i = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,772 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
; i start address is: 8 (W4)
	CLR	W4
; i end address is: 8 (W4)
L_ClearFlake94:
; i start address is: 8 (W4)
	CP	W4, #2
	BRA LE	L__ClearFlake216
	GOTO	L_ClearFlake95
L__ClearFlake216:
;main.c,783 :: 		clear_up_down_flake.left = flakes[i].x;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_flakes), W0
	ADD	W0, W2, W3
	MOV	[W3], W2
	MOV	W2, _clear_up_down_flake+2
;main.c,784 :: 		clear_up_down_flake.top = flakes[i].prev_y;
	ADD	W3, #6, W0
	MOV	[W0], W0
	MOV	W0, _clear_up_down_flake
;main.c,785 :: 		clear_up_down_flake.right = flakes[i].x + flakes[i].width;
	MOV	[W3], W1
	ADD	W3, #12, W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_up_down_flake+6
;main.c,787 :: 		clear_up_down_flake.bottom = flakes[i].y;
	ADD	W3, #2, W0
	MOV	[W0], W0
	MOV	W0, _clear_up_down_flake+4
;main.c,791 :: 		if (clear_up_down_flake.left < 0) {
	CP	W2, #0
	BRA LT	L__ClearFlake217
	GOTO	L_ClearFlake97
L__ClearFlake217:
;main.c,792 :: 		clear_up_down_flake.left = 0;
	CLR	W0
	MOV	W0, _clear_up_down_flake+2
;main.c,793 :: 		}
L_ClearFlake97:
;main.c,794 :: 		if (clear_up_down_flake.top < 0) {
	MOV	_clear_up_down_flake, W0
	CP	W0, #0
	BRA LT	L__ClearFlake218
	GOTO	L_ClearFlake98
L__ClearFlake218:
;main.c,795 :: 		clear_up_down_flake.top = 0;
	CLR	W0
	MOV	W0, _clear_up_down_flake
;main.c,796 :: 		}
L_ClearFlake98:
;main.c,797 :: 		if (clear_up_down_flake.right < 0) {
	MOV	_clear_up_down_flake+6, W0
	CP	W0, #0
	BRA LT	L__ClearFlake219
	GOTO	L_ClearFlake99
L__ClearFlake219:
;main.c,798 :: 		clear_up_down_flake.right = 0;
	CLR	W0
	MOV	W0, _clear_up_down_flake+6
;main.c,799 :: 		}
L_ClearFlake99:
;main.c,800 :: 		if (clear_up_down_flake.bottom < 0) {
	MOV	_clear_up_down_flake+4, W0
	CP	W0, #0
	BRA LT	L__ClearFlake220
	GOTO	L_ClearFlake100
L__ClearFlake220:
;main.c,801 :: 		clear_up_down_flake.bottom = 0;
	CLR	W0
	MOV	W0, _clear_up_down_flake+4
;main.c,802 :: 		}
L_ClearFlake100:
;main.c,805 :: 		TFT_Set_Pen(sky_color, 1);
	MOV	#1, W11
	MOV	_sky_color, W10
	CALL	_TFT_Set_Pen
;main.c,808 :: 		TFT_Set_Brush(1, sky_color, 0, TOP_TO_BOTTOM, sky_color, sky_color);
	CLR	W13
	CLR	W12
	MOV	_sky_color, W11
	MOV	#1, W10
	PUSH	_sky_color
	PUSH	_sky_color
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;main.c,821 :: 		if( clear_up_down_flake.bottom > clear_up_down_flake.top){
	MOV	_clear_up_down_flake+4, W1
	MOV	#lo_addr(_clear_up_down_flake), W0
	CP	W1, [W0]
	BRA GT	L__ClearFlake221
	GOTO	L_ClearFlake101
L__ClearFlake221:
;main.c,823 :: 		TFT_Rectangle(clear_up_down_flake.left, clear_up_down_flake.top, clear_up_down_flake.right, clear_up_down_flake.bottom);
	PUSH	W4
	MOV	_clear_up_down_flake+4, W13
	MOV	_clear_up_down_flake+6, W12
	MOV	_clear_up_down_flake, W11
	MOV	_clear_up_down_flake+2, W10
	CALL	_TFT_Rectangle
	POP	W4
;main.c,824 :: 		}
L_ClearFlake101:
;main.c,772 :: 		for(i=0;i<=(NUMBER_OF_FLAKES-1);i++){
	INC	W4
;main.c,825 :: 		}
; i end address is: 8 (W4)
	GOTO	L_ClearFlake94
L_ClearFlake95:
;main.c,826 :: 		}
L_end_ClearFlake:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ClearFlake

_ToggleMute:

;main.c,832 :: 		void ToggleMute(){
;main.c,834 :: 		if(muteSound){
	PUSH	W10
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA NZ	L__ToggleMute223
	GOTO	L_ToggleMute102
L__ToggleMute223:
;main.c,835 :: 		muteSound = 0;
	CLR	W0
	MOV	W0, _muteSound
;main.c,836 :: 		UART2_Write_Line("Sound On");
	MOV	#lo_addr(?lstr3_main), W10
	CALL	_UART2_Write_Line
;main.c,837 :: 		}
	GOTO	L_ToggleMute103
L_ToggleMute102:
;main.c,838 :: 		else if(!muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA Z	L__ToggleMute224
	GOTO	L_ToggleMute104
L__ToggleMute224:
;main.c,840 :: 		muteSound = 1;
	MOV	#1, W0
	MOV	W0, _muteSound
;main.c,841 :: 		UART2_Write_Line("Muting Sound");
	MOV	#lo_addr(?lstr4_main), W10
	CALL	_UART2_Write_Line
;main.c,842 :: 		}
L_ToggleMute104:
L_ToggleMute103:
;main.c,844 :: 		}
L_end_ToggleMute:
	POP	W10
	RETURN
; end of _ToggleMute

_PreRollSong:
	LNK	#4

;main.c,848 :: 		void PreRollSong(){
;main.c,849 :: 		int roll = 0;
;main.c,850 :: 		int roll_max = 100;   //100
	MOV	#100, W0
	MOV	W0, [W14+2]
;main.c,853 :: 		for(roll = 0; roll<=roll_max;roll++){
	CLR	W0
	MOV	W0, [W14+0]
L_PreRollSong105:
	MOV	[W14+0], W1
	ADD	W14, #2, W0
	CP	W1, [W0]
	BRA LE	L__PreRollSong226
	GOTO	L_PreRollSong106
L__PreRollSong226:
;main.c,854 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;main.c,853 :: 		for(roll = 0; roll<=roll_max;roll++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;main.c,855 :: 		}
	GOTO	L_PreRollSong105
L_PreRollSong106:
;main.c,856 :: 		}
L_end_PreRollSong:
	ULNK
	RETURN
; end of _PreRollSong

_GetNextSong:

;main.c,859 :: 		void GetNextSong(){
;main.c,860 :: 		UART2_Write_Line("Switching to the next song.");
	PUSH	W10
	MOV	#lo_addr(?lstr5_main), W10
	CALL	_UART2_Write_Line
;main.c,862 :: 		Load_MP3_File("tff.mp3");
	MOV	#lo_addr(?lstr6_main), W10
	CALL	_Load_MP3_File
;main.c,865 :: 		if(current_pos < 5){
	MOV	_current_pos, W0
	MOV	_current_pos+2, W1
	CP	W0, #5
	CPB	W1, #0
	BRA LT	L__GetNextSong228
	GOTO	L_GetNextSong108
L__GetNextSong228:
;main.c,866 :: 		PreRollSong();
	CALL	_PreRollSong
;main.c,867 :: 		}
L_GetNextSong108:
;main.c,869 :: 		}
L_end_GetNextSong:
	POP	W10
	RETURN
; end of _GetNextSong

_RenderScore:

;main.c,874 :: 		void RenderScore(){
;main.c,877 :: 		if(muteSound){
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA NZ	L__RenderScore230
	GOTO	L_RenderScore109
L__RenderScore230:
;main.c,880 :: 		TFT_Write_Text("Tap bar to enable music.", 10, 240-STATUS_TEXT_HEIGHT+3);
	MOV	#218, W12
	MOV	#10, W11
	MOV	#lo_addr(?lstr7_main), W10
	CALL	_TFT_Write_Text
;main.c,881 :: 		}
	GOTO	L_RenderScore110
L_RenderScore109:
;main.c,882 :: 		else if(!muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA Z	L__RenderScore231
	GOTO	L_RenderScore111
L__RenderScore231:
;main.c,885 :: 		TFT_Write_Text("Tap bar to mute music.", 10, 240-STATUS_TEXT_HEIGHT+3);
	MOV	#218, W12
	MOV	#10, W11
	MOV	#lo_addr(?lstr8_main), W10
	CALL	_TFT_Write_Text
;main.c,886 :: 		}
L_RenderScore111:
L_RenderScore110:
;main.c,893 :: 		LongToStr(score, score_text);
	MOV	#lo_addr(_score_text), W12
	MOV	_score, W10
	MOV	_score+2, W11
	CALL	_LongToStr
;main.c,896 :: 		TFT_Set_Font(TFT_defaultFont, sky_color, FO_HORIZONTAL);
	CLR	W13
	MOV	_sky_color, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;main.c,899 :: 		strcpy(score_display_text, "Score: ");
	MOV	#lo_addr(?lstr9_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;main.c,900 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;main.c,904 :: 		TFT_Write_Text(score_display_text, 200, 240-STATUS_TEXT_HEIGHT+3);
	MOV	#218, W12
	MOV	#200, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;main.c,905 :: 		}
L_end_RenderScore:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _RenderScore

_ShowTitles:

;main.c,908 :: 		void ShowTitles(){
;main.c,909 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,912 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;main.c,915 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,918 :: 		TFT_Image(32, 50, title_bmp, 1);
	MOV	#lo_addr(_title_bmp), W0
	MOV	#higher_addr(_title_bmp), W1
	MOV.D	W0, W12
	MOV	#50, W11
	MOV	#32, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,920 :: 		TFT_Write_Text("Tap    to    melt    the    snowflakes.", 60, 140);
	MOV	#140, W12
	MOV	#60, W11
	MOV	#lo_addr(?lstr10_main), W10
	CALL	_TFT_Write_Text
;main.c,922 :: 		TFT_Write_Text("Created   By   Andrew   Hazelden    (c)  2011", 30, 220);
	MOV	#220, W12
	MOV	#30, W11
	MOV	#lo_addr(?lstr11_main), W10
	CALL	_TFT_Write_Text
;main.c,924 :: 		GetNextSong();
	CALL	_GetNextSong
;main.c,933 :: 		if(muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA NZ	L__ShowTitles233
	GOTO	L_ShowTitles112
L__ShowTitles233:
;main.c,934 :: 		Delay_ms(4000);
	MOV	#652, W8
	MOV	#2946, W7
L_ShowTitles113:
	DEC	W7
	BRA NZ	L_ShowTitles113
	DEC	W8
	BRA NZ	L_ShowTitles113
	NOP
	NOP
;main.c,935 :: 		}
L_ShowTitles112:
;main.c,938 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,940 :: 		}
L_end_ShowTitles:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowTitles

_ShowGameOver:

;main.c,942 :: 		void ShowGameOver(){
;main.c,943 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;main.c,945 :: 		UART2_Write_Line("Game Over");
	MOV	#lo_addr(?lstr12_main), W10
	CALL	_UART2_Write_Line
;main.c,948 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;main.c,951 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,954 :: 		TFT_Image(32, 50, GameOver_bmp, 1);
	MOV	#lo_addr(_gameover_bmp), W0
	MOV	#higher_addr(_gameover_bmp), W1
	MOV.D	W0, W12
	MOV	#50, W11
	MOV	#32, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;main.c,958 :: 		if(score > high_score){
	MOV	_score, W1
	MOV	_score+2, W2
	MOV	#lo_addr(_high_score), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GT	L__ShowGameOver235
	GOTO	L_ShowGameOver115
L__ShowGameOver235:
;main.c,960 :: 		high_score = score;
	MOV	_score, W0
	MOV	_score+2, W1
	MOV	W0, _high_score
	MOV	W1, _high_score+2
;main.c,961 :: 		TFT_Write_Text("You  set  a  High  Score!", 95, 140);
	MOV	#140, W12
	MOV	#95, W11
	MOV	#lo_addr(?lstr13_main), W10
	CALL	_TFT_Write_Text
;main.c,962 :: 		}
	GOTO	L_ShowGameOver116
L_ShowGameOver115:
;main.c,967 :: 		LongWordToStr(high_score, score_text);
	MOV	#lo_addr(_score_text), W12
	MOV	_high_score, W10
	MOV	_high_score+2, W11
	CALL	_LongWordToStr
;main.c,968 :: 		strcpy(score_display_text, "High  Score: ");
	MOV	#lo_addr(?lstr14_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;main.c,969 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;main.c,972 :: 		TFT_Write_Text(score_display_text, 110, 140);
	MOV	#140, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;main.c,973 :: 		}
L_ShowGameOver116:
;main.c,976 :: 		LongWordToStr(score, score_text);
	MOV	#lo_addr(_score_text), W12
	MOV	_score, W10
	MOV	_score+2, W11
	CALL	_LongWordToStr
;main.c,977 :: 		strcpy(score_display_text, "Your  Score: ");
	MOV	#lo_addr(?lstr15_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;main.c,978 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;main.c,981 :: 		TFT_Write_Text(score_display_text, 110, 170);
	MOV	#170, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;main.c,984 :: 		UART2_Write_Line(score_display_text);
	MOV	#lo_addr(_score_display_text), W10
	CALL	_UART2_Write_Line
;main.c,986 :: 		TFT_Write_Text("Tip:   Melt   the   small   snowflakes   first!", 45, 215);
	MOV	#215, W12
	MOV	#45, W11
	MOV	#lo_addr(?lstr16_main), W10
	CALL	_TFT_Write_Text
;main.c,989 :: 		for(loop = 0; loop<=60;loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowGameOver117:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowGameOver236
	GOTO	L_ShowGameOver118
L__ShowGameOver236:
;main.c,990 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;main.c,991 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowGameOver120:
	DEC	W7
	BRA NZ	L_ShowGameOver120
	DEC	W8
	BRA NZ	L_ShowGameOver120
;main.c,993 :: 		if(muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA NZ	L__ShowGameOver237
	GOTO	L_ShowGameOver122
L__ShowGameOver237:
;main.c,994 :: 		Delay_ms(20);
	MOV	#4, W8
	MOV	#16725, W7
L_ShowGameOver123:
	DEC	W7
	BRA NZ	L_ShowGameOver123
	DEC	W8
	BRA NZ	L_ShowGameOver123
	NOP
;main.c,995 :: 		}
L_ShowGameOver122:
;main.c,989 :: 		for(loop = 0; loop<=60;loop++){
	INC	W1
;main.c,997 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowGameOver117
L_ShowGameOver118:
;main.c,1002 :: 		TFT_Fill_Screen(sky_color);
	MOV	_sky_color, W10
	CALL	_TFT_Fill_Screen
;main.c,1004 :: 		}
L_end_ShowGameOver:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowGameOver
